## scalapack 1.8.0

=== Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Top-level Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include SLmake.inc

#PRECISIONS = single double complex complex16 FRC=FRC
PRECISIONS = single double complex complex16

############################################################################
#
#  The library can be set up to include routines for any combination of the
#  four PRECISIONS.  First, modify the ARCH, ARCHFLAGS, RANLIB, F77, CC,
#  F77FLAGS, CCFLAGS, F77LOADER, CCLOADER, F77LOADFLAGS, CCLOADFLAGS and
#  CDEFS definitions in SLmake.inc to match your library archiver, compiler
#  and the options to be used.
#
#  The command
#       make
#  without any arguments creates the library of precisions defined by the
#  environment variable PRECISIONS as well as the corresponding testing
#  executables,
#       make lib
#  creates only the library,
#       make exe
#  creates only the testing executables.
#       make example
#  creates only the example
#
#  The name of the library is defined in the file called SLmake.inc and
#  is created at this directory level.
#
#  To remove the object files after the library and testing executables
#  are created, enter
#       make clean
#
############################################################################

all: lib
#all: lib exe example

lib: toolslib pblaslib redistlib scalapacklib

exe: pblasexe redistexe scalapackexe

clean: cleanlib cleanexe cleanexample

pblaslib:
	( cd $(PBLASdir)/SRC; $(MAKE) $(PRECISIONS) )

redistlib:
	( cd $(REDISTdir)/SRC; $(MAKE) integer $(PRECISIONS) )

scalapacklib:
	( cd $(SRCdir); $(MAKE) $(PRECISIONS) )

toolslib:
	( cd $(TOOLSdir); $(MAKE) $(PRECISIONS) )

pblasexe:
	( cd $(PBLASdir)/TESTING; $(MAKE) $(PRECISIONS) )
	( cd $(PBLASdir)/TIMING; $(MAKE) $(PRECISIONS) )

scalapackexe:
	( cd $(TESTdir)/LIN; $(MAKE) $(PRECISIONS) )
	( cd $(TESTdir)/EIG; $(MAKE) $(PRECISIONS) )

redistexe:
	( cd $(REDISTdir)/TESTING; $(MAKE) integer $(PRECISIONS) )

example:
	( cd EXAMPLE; $(MAKE) $(PRECISIONS) )

cleanexe:
	( cd $(PBLASdir)/TESTING; $(MAKE) clean )
	( cd $(PBLASdir)/TIMING; $(MAKE) clean )
	( cd $(TESTdir)/LIN; $(MAKE) clean )
	( cd $(TESTdir)/EIG; $(MAKE) clean )
	( cd $(REDISTdir)/TESTING; $(MAKE) clean )

cleanlib:
	( cd $(PBLASdir)/SRC; $(MAKE) clean )
	( cd $(SRCdir); $(MAKE) clean )
	( cd $(TOOLSdir); $(MAKE) clean )
	( cd $(REDISTdir)/SRC; $(MAKE) clean )

cleanexample:
	( cd EXAMPLE; $(MAKE) clean )

=== EXAMPLE/Makefile ===
include ../SLmake.inc

TESTOBJS = psscaex.o pdscaexinfo.o
TESTOBJD = pdscaex.o pdscaexinfo.o
TESTOBJC = pcscaex.o pdscaexinfo.o
TESTOBJZ = pzscaex.o pdscaexinfo.o

all: pdscaex pcscaex pzscaex psscaex

single: psscaex

double: pdscaex

complex: pcscaex

complex16: pzscaex

$(TESTINGdir)/SCAEX.dat: SCAEX.dat
	cp SCAEX.dat $(TESTINGdir)

$(TESTINGdir)/SSCAEXMAT.dat: SSCAEXMAT.dat
	cp SSCAEXMAT.dat $(TESTINGdir)

$(TESTINGdir)/SSCAEXRHS.dat: SSCAEXRHS.dat
	cp SSCAEXRHS.dat $(TESTINGdir)

psscaex: $(TESTOBJS)
	$(F77LOADER) $(F77LOADFLAGS) -o $(TESTINGdir)/xsscaex $(TESTOBJS) $(LIBS)
	$(MAKE) $(TESTINGdir)/SCAEX.dat
	$(MAKE) $(TESTINGdir)/SSCAEXMAT.dat
	$(MAKE) $(TESTINGdir)/SSCAEXRHS.dat

$(TESTINGdir)/ZSCAEXMAT.dat: ZSCAEXMAT.dat
	cp ZSCAEXMAT.dat $(TESTINGdir)

$(TESTINGdir)/ZSCAEXRHS.dat: ZSCAEXRHS.dat
	cp ZSCAEXRHS.dat $(TESTINGdir)

pzscaex: $(TESTOBJZ)
	$(F77LOADER) $(F77LOADFLAGS) -o $(TESTINGdir)/xzscaex $(TESTOBJZ) $(LIBS)
	$(MAKE) $(TESTINGdir)/SCAEX.dat
	$(MAKE) $(TESTINGdir)/ZSCAEXMAT.dat
	$(MAKE) $(TESTINGdir)/ZSCAEXRHS.dat

$(TESTINGdir)/CSCAEXMAT.dat: CSCAEXMAT.dat
	cp CSCAEXMAT.dat $(TESTINGdir)

$(TESTINGdir)/CSCAEXRHS.dat: CSCAEXRHS.dat
	cp CSCAEXRHS.dat $(TESTINGdir)

pcscaex: $(TESTOBJC)
	$(F77LOADER) $(F77LOADFLAGS) -o $(TESTINGdir)/xcscaex $(TESTOBJC) $(LIBS)
	$(MAKE) $(TESTINGdir)/SCAEX.dat
	$(MAKE) $(TESTINGdir)/CSCAEXMAT.dat
	$(MAKE) $(TESTINGdir)/CSCAEXRHS.dat

$(TESTINGdir)/DSCAEXMAT.dat: DSCAEXMAT.dat
	cp DSCAEXMAT.dat $(TESTINGdir)

$(TESTINGdir)/DSCAEXRHS.dat: DSCAEXRHS.dat
	cp DSCAEXRHS.dat $(TESTINGdir)

pdscaex: $(TESTOBJD)
	$(F77LOADER) $(F77LOADFLAGS) -o $(TESTINGdir)/xdscaex $(TESTOBJD) $(LIBS)
	$(MAKE) $(TESTINGdir)/SCAEX.dat
	$(MAKE) $(TESTINGdir)/DSCAEXMAT.dat
	$(MAKE) $(TESTINGdir)/DSCAEXRHS.dat

clean :
	rm -f *.o

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

.c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) $*.c

=== SRC/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         SRC Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../SLmake.inc

#######################################################################
#  This is the makefile to create a library for ScaLAPACK.
#  The files are organized as follows:
#       ALLAUX -- Auxiliary routines called from all precisions
#       SCLAUX -- Auxiliary routines called from both REAL and COMPLEX
#       DZLAUX -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#       SLASRC -- Single precision real ScaLAPACK routines
#       CLASRC -- Single precision complex ScaLAPACK routines
#       DLASRC -- Double precision real ScaLAPACK routines
#       ZLASRC -- Double precision complex ScaLAPACK routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ARCH, ARCHFLAGS, RANLIB,
#  F77 and F77FLAGS definitions in ../SLmake.inc to match your library
#  archiver, compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is defined by $(SCALAPACKLIB) in
#  ../SLmake.inc and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

ALLAUX = pjlaenv.o

SCLAUX = \
   pslabad.o pslaed0.o pslaed1.o pslaed2.o pslaed3.o pslaedz.o pslaiect.o \
   pslamch.o pslared1d.o pslasrt.o psstebz.o psstedc.o slapst.o slasrt2.o \
   sstein2.o pbchkvect.o getpbbuf.o

DZLAUX = \
   pdlabad.o pdlaed0.o pdlaed1.o pdlaed2.o pdlaed3.o pdlaedz.o pdlaiect.o \
   pdlamch.o pdlared1d.o pdlasrt.o pdstebz.o pdstedc.o dlapst.o dlasrt2.o \
   dstein2.o pbchkvect.o getpbbuf.o

SLASRC = \
   psdbsv.o  psdbtrf.o psdbtrs.o psdbtrsv.o \
   psdtsv.o  psdttrf.o psdttrs.o psdttrsv.o \
   psgbsv.o  psgbtrf.o psgbtrs.o \
   psgebd2.o psgebrd.o psgecon.o           psgeequ.o psgehd2.o psgehrd.o \
   psgelq2.o psgelqf.o psgels.o  psgeql2.o psgeqlf.o psgeqpf.o psgeqr2.o \
   psgeqrf.o psgerfs.o psgerq2.o psgerqf.o                               \
   psgesv.o  psgesvd.o psgesvx.o psgetf2.o psgetrf.o psgetri.o psgetrs.o \
   psggqrf.o psggrqf.o pslabrd.o \
   pslacon.o pslacp2.o pslacpy.o pslahrd.o pslange.o pslanhs.o pslansy.o \
   pslantr.o pslapiv.o pslapv2.o pslaqge.o pslaqsy.o pslarf.o  pslarfb.o \
   pslarfg.o pslarft.o pslase2.o pslaset.o pslascl.o pslassq.o pslaswp.o \
   pslatra.o pslatrd.o pslatrs.o pslauu2.o pslauum.o psorg2l.o psorg2r.o \
                       psorgl2.o psorglq.o psorgql.o psorgqr.o psorgr2.o \
   psorgrq.o           psorm2l.o psorm2r.o psormbr.o psormhr.o psorml2.o \
   psormlq.o psormql.o psormqr.o psormr2.o psormrq.o psormtr.o pspocon.o \
   pspbsv.o  pspbtrf.o pspbtrs.o pspbtrsv.o \
   psptsv.o  pspttrf.o pspttrs.o pspttrsv.o \
   pspoequ.o psporfs.o psposv.o  psposvx.o pspotf2.o pspotrf.o pspotri.o \
   pspotrs.o psrscl.o  psstein.o pssyev.o  pssyevd.o pssyevx.o \
   pssygs2.o pssygst.o \
   pssygvx.o pssyngst.o pssyntrd.o  pssyttrd.o pssytd2.o pssytrd.o \
   pstrti2.o pstrtri.o pstrtrs.o \
   pslaevswp.o \
   pslarzb.o pslarzt.o pslarz.o pslatrz.o pstzrzf.o psormr3.o psormrz.o \
   pslahqr.o pslaconsb.o pslacp3.o pslawil.o \
   pslasmsub.o pslared2d.o pslamr1d.o slaref.o slamsh.o slasorte.o ssteqr2.o \
   sdbtf2.o  sdbtrf.o  sdttrf.o sdttrsv.o spttrsv.o strmvt.o
   
CLASRC = \
   pcdbsv.o  pcdbtrf.o pcdbtrs.o pcdbtrsv.o \
   pcdtsv.o  pcdttrf.o pcdttrs.o pcdttrsv.o \
   pcgbsv.o  pcgbtrf.o pcgbtrs.o \
   pcgebd2.o pcgebrd.o pcgecon.o          pcgeequ.o pcgehd2.o pcgehrd.o \
   pcgelq2.o pcgelqf.o  pcgels.o pcgeql2.o pcgeqlf.o pcgeqpf.o pcgeqr2.o \
   pcgeqrf.o pcgerfs.o pcgerq2.o pcgerqf.o                               \
   pcgesv.o  pcgesvd.o pcgesvx.o pcgetf2.o pcgetrf.o pcgetri.o pcgetrs.o \
   pcggqrf.o \
   pcggrqf.o pcheev.o  pcheevd.o pcheevx.o pchegs2.o pchegst.o pchegvx.o \
   pchengst.o pchentrd.o pchettrd.o pchetd2.o \
   pchetrd.o pclabrd.o pclacon.o pclacgv.o pclacp2.o pclacpy.o pclahrd.o \
   pclahqr.o pclaconsb.o pclasmsub.o pclacp3.o pclawil.o pcrot.o \
   pclange.o pclanhe.o pclanhs.o pclansy.o pclantr.o pclapiv.o pclapv2.o \
   pclaqge.o pclaqsy.o pclarf.o  pclarfb.o pclarfc.o pclarfg.o pclarft.o \
   pclascl.o pclase2.o pclaset.o pclassq.o pclaswp.o pclatra.o pclatrd.o \
   pclatrs.o pclauu2.o pclauum.o pcpocon.o pcpoequ.o pcporfs.o pcposv.o  \
   pcpbsv.o  pcpbtrf.o pcpbtrs.o pcpbtrsv.o \
   pcptsv.o  pcpttrf.o pcpttrs.o pcpttrsv.o \
   pcposvx.o pcpotf2.o pcpotrf.o pcpotri.o pcpotrs.o pcsrscl.o pcstein.o \
   pctrevc.o pctrti2.o pctrtri.o pctrtrs.o pcung2l.o pcung2r.o \
             pcungl2.o pcunglq.o pcungql.o pcungqr.o pcungr2.o pcungrq.o \
             pcunm2l.o pcunm2r.o pcunmbr.o pcunmhr.o pcunml2.o pcunmlq.o \
   pcunmql.o pcunmqr.o pcunmr2.o pcunmrq.o pcunmtr.o \
   pclaevswp.o \
   pclarzb.o pclarzt.o pclarz.o  pclarzc.o pclatrz.o pctzrzf.o \
   pclattrs.o \
   pcunmr3.o pcunmrz.o pcmax1.o pscsum1.o pclamr1d.o \
   cdbtf2.o  cdbtrf.o  cdttrf.o cdttrsv.o  cpttrsv.o csteqr2.o ctrmvt.o \
   clamsh.o  claref.o  clanv2.o clahqr2.o

DLASRC = \
   pddbsv.o  pddbtrf.o pddbtrs.o pddbtrsv.o \
   pddtsv.o  pddttrf.o pddttrs.o pddttrsv.o \
   pdgbsv.o  pdgbtrf.o pdgbtrs.o \
   pdgebd2.o pdgebrd.o pdgecon.o           pdgeequ.o pdgehd2.o pdgehrd.o \
   pdgelq2.o pdgelqf.o pdgels.o  pdgeql2.o pdgeqlf.o pdgeqpf.o pdgeqr2.o \
   pdgeqrf.o pdgerfs.o pdgerq2.o pdgerqf.o                               \
   pdgesv.o  pdgesvd.o pdgesvx.o pdgetf2.o pdgetrf.o pdgetri.o pdgetrs.o \
   pdggqrf.o pdggrqf.o pdlabrd.o \
   pdlacon.o pdlacp2.o pdlacpy.o pdlahrd.o pdlange.o pdlanhs.o pdlansy.o \
   pdlantr.o pdlapiv.o pdlapv2.o pdlaqge.o pdlaqsy.o pdlarf.o  pdlarfb.o \
   pdlarfg.o pdlarft.o pdlase2.o pdlaset.o pdlascl.o pdlassq.o pdlaswp.o \
   pdlatra.o pdlatrd.o pdlatrs.o pdlauu2.o pdlauum.o pdorg2l.o pdorg2r.o \
                       pdorgl2.o pdorglq.o pdorgql.o pdorgqr.o pdorgr2.o \
   pdorgrq.o           pdorm2l.o pdorm2r.o pdormbr.o pdormhr.o pdorml2.o \
   pdormlq.o pdormql.o pdormqr.o pdormr2.o pdormrq.o pdormtr.o pdpocon.o \
   pdpbsv.o  pdpbtrf.o pdpbtrs.o pdpbtrsv.o \
   pdptsv.o  pdpttrf.o pdpttrs.o pdpttrsv.o \
   pdpoequ.o pdporfs.o pdposv.o  pdposvx.o pdpotf2.o pdpotrf.o pdpotri.o \
   pdpotrs.o pdrscl.o  pdstein.o pdsyev.o  pdsyevd.o pdsyevx.o \
   pdsygs2.o pdsygst.o \
   pdsygvx.o pdsyngst.o pdsyntrd.o pdsyttrd.o pdsytd2.o pdsytrd.o pdtrti2.o \
   pdtrtri.o pdtrtrs.o \
   pdlaevswp.o \
   pdlarzb.o pdlarzt.o pdlarz.o pdlatrz.o pdtzrzf.o pdormr3.o pdormrz.o \
   pdlahqr.o pdlaconsb.o pdlacp3.o pdlawil.o \
   pdlasmsub.o pdlared2d.o pdlamr1d.o dlaref.o dlamsh.o dlasorte.o dsteqr2.o \
   ddbtf2.o  ddbtrf.o  ddttrf.o ddttrsv.o dpttrsv.o dtrmvt.o

ZLASRC = \
   pzdbsv.o  pzdbtrf.o pzdbtrs.o pzdbtrsv.o \
   pzdtsv.o  pzdttrf.o pzdttrs.o pzdttrsv.o \
   pzgbsv.o  pzgbtrf.o pzgbtrs.o \
   pzgebd2.o pzgebrd.o pzgecon.o           pzgeequ.o pzgehd2.o pzgehrd.o \
   pzgelq2.o pzgelqf.o pzgels.o  pzgeql2.o pzgeqlf.o pzgeqpf.o pzgeqr2.o \
   pzgeqrf.o pzgerfs.o pzgerq2.o pzgerqf.o                               \
   pzgesv.o  pzgesvd.o pzgesvx.o pzgetf2.o pzgetrf.o pzgetri.o pzgetrs.o \
   pzggqrf.o \
   pzggrqf.o pzheev.o  pzheevd.o pzheevx.o pzhegs2.o pzhegst.o pzhegvx.o \
   pzhengst.o pzhentrd.o pzhettrd.o pzhetd2.o \
   pzhetrd.o pzlabrd.o pzlacon.o pzlacgv.o pzlacp2.o pzlacpy.o pzlahrd.o \
   pzlahqr.o pzlaconsb.o pzlasmsub.o pzlacp3.o pzlawil.o pzrot.o \
   pzlange.o pzlanhe.o pzlanhs.o pzlansy.o pzlantr.o pzlapiv.o pzlapv2.o \
   pzlaqge.o pzlaqsy.o pzlarf.o  pzlarfb.o pzlarfc.o pzlarfg.o pzlarft.o \
   pzlascl.o pzlase2.o pzlaset.o pzlassq.o pzlaswp.o pzlatra.o pzlatrd.o \
   pzlattrs.o \
   pzlatrs.o pzlauu2.o pzlauum.o pzpocon.o pzpoequ.o pzporfs.o pzposv.o  \
   pzpbsv.o  pzpbtrf.o pzpbtrs.o pzpbtrsv.o \
   pzptsv.o  pzpttrf.o pzpttrs.o pzpttrsv.o \
   pzposvx.o pzpotf2.o pzpotrf.o pzpotri.o pzpotrs.o pzdrscl.o pzstein.o \
   pztrevc.o pztrti2.o pztrtri.o pztrtrs.o pzung2l.o pzung2r.o \
             pzungl2.o pzunglq.o pzungql.o pzungqr.o pzungr2.o pzungrq.o \
             pzunm2l.o pzunm2r.o pzunmbr.o pzunmhr.o pzunml2.o pzunmlq.o \
   pzunmql.o pzunmqr.o pzunmr2.o pzunmrq.o pzunmtr.o \
   pzlaevswp.o \
   pzlarzb.o pzlarzt.o pzlarz.o  pzlarzc.o pzlatrz.o pztzrzf.o \
   pzunmr3.o pzunmrz.o pzmax1.o pdzsum1.o pzlamr1d.o \
   zdbtf2.o  zdbtrf.o  zdttrf.o zdttrsv.o  zpttrsv.o zsteqr2.o ztrmvt.o \
   zlamsh.o  zlaref.o  zlanv2.o zlahqr2.o

all: single complex double complex16

single: $(SLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(SLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex: $(CLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(CLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

double: $(DLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(DLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex16: $(ZLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(ZLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

$(SCLAUX): $(FRC)
$(DZLAUX): $(FRC)
$(SLASRC): $(FRC)
$(CLASRC): $(FRC)
$(DLASRC): $(FRC)
$(ZLASRC): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

.c.o : ; $(CC) -c $(CCFLAGS) $(SRCFLAG) $(CDEFS) $*.c

=== TOOLS/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Tools Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../SLmake.inc

ATOOLS = iceil.o      ilacpy.o     ilcm.o       indxg2p.o    indxg2l.o    \
         indxl2g.o    infog1l.o    infog2l.o    npreroc.o    numroc.o     \
         chk1mat.o    pchkxmat.o   sltimer.o    desc_convert.o \
         descinit.o   descset.o    reshape.o    SL_gridreshape.o \
         SL_init.o

ITOOLS = picol2row.o  pirow2col.o  pilaprnt.o   pitreecomb.o  pifillpad.o  \
         pichekpad.o  pielset.o    pielset2.o   pielget.o

STOOLS = dsnrm2.o     dsasum.o     slatcpy.o    ssdot.o       smatadd.o   \
         psmatadd.o   pscol2row.o  psrow2col.o  pslaprnt.o    pstreecomb.o \
         psfillpad.o  pschekpad.o  pselset.o    pselset2.o    pselget.o \
         pslaread.o   pslawrite.o

DTOOLS = dddot.o      dlatcpy.o    dmatadd.o    pdmatadd.o    pdcol2row.o \
         pdrow2col.o  pdlaprnt.o   pdtreecomb.o pdfillpad.o   pdchekpad.o \
         pdelset.o    pdelset2.o   pdelget.o \
         pdlaread.o   pdlawrite.o

CTOOLS = dscnrm2.o    dscasum.o    ccdotu.o     ccdotc.o      clatcpy.o \
         cmatadd.o    pcmatadd.o   pccol2row.o  pcrow2col.o   pclaprnt.o \
         pctreecomb.o pcfillpad.o  pcchekpad.o  pcelset.o     pcelset2.o \
         pcelget.o \
         pclaread.o   pclawrite.o

ZTOOLS = zzdotu.o     zzdotc.o     zlatcpy.o    zmatadd.o     pzmatadd.o \
         pzcol2row.o  pzrow2col.o  pzlaprnt.o   pztreecomb.o  pzfillpad.o \
         pzchekpad.o  pzelset.o    pzelset2.o   pzelget.o \
         pzlaread.o   pzlawrite.o

all: single double complex complex16

slapackaux:
	( cd LAPACK; $(MAKE) single FRC=$(FRC) )

dlapackaux:
	( cd LAPACK; $(MAKE) double FRC=$(FRC) )

clapackaux:
	( cd LAPACK; $(MAKE) complex FRC=$(FRC) )

zlapackaux:
	( cd LAPACK; $(MAKE) complex16 FRC=$(FRC) )

integer: $(ATOOLS) $(ITOOLS)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(ATOOLS) $(ITOOLS)
	$(RANLIB) $(SCALAPACKLIB)

single: slapackaux integer $(STOOLS)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(STOOLS)
	$(RANLIB) $(SCALAPACKLIB)

double: dlapackaux integer $(DTOOLS)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(DTOOLS)
	$(RANLIB) $(SCALAPACKLIB)

complex: clapackaux integer $(CTOOLS)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(CTOOLS)
	$(RANLIB) $(SCALAPACKLIB)

complex16: zlapackaux integer $(ZTOOLS)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(ZTOOLS)
	$(RANLIB) $(SCALAPACKLIB)

$(ATOOLS): $(FRC)
$(ITOOLS): $(FRC)
$(STOOLS): $(FRC)
$(DTOOLS): $(FRC)
$(CTOOLS): $(FRC)
$(ZTOOLS): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o
	( cd LAPACK; $(MAKE) clean )

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

.c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) $*.c

=== PBLAS/TESTING/Makefile ===
############################################################################
#
#  Program:         PBLAS -- (version 2.0)
#
#  Module:          Makefile
#
#  Purpose:         Testing Makefile
#
#  Creation date:   April 1, 1998
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

sPBLAS1exe    = xspblas1tst
dPBLAS1exe    = xdpblas1tst
cPBLAS1exe    = xcpblas1tst
zPBLAS1exe    = xzpblas1tst

sPBLAS2exe    = xspblas2tst
dPBLAS2exe    = xdpblas2tst
cPBLAS2exe    = xcpblas2tst
zPBLAS2exe    = xzpblas2tst

sPBLAS3exe    = xspblas3tst
dPBLAS3exe    = xdpblas3tst
cPBLAS3exe    = xcpblas3tst
zPBLAS3exe    = xzpblas3tst

spb1tst       = $(PBLASTSTdir)/$(sPBLAS1exe)
dpb1tst       = $(PBLASTSTdir)/$(dPBLAS1exe)
cpb1tst       = $(PBLASTSTdir)/$(cPBLAS1exe)
zpb1tst       = $(PBLASTSTdir)/$(zPBLAS1exe)

spb2tst       = $(PBLASTSTdir)/$(sPBLAS2exe)
dpb2tst       = $(PBLASTSTdir)/$(dPBLAS2exe)
cpb2tst       = $(PBLASTSTdir)/$(cPBLAS2exe)
zpb2tst       = $(PBLASTSTdir)/$(zPBLAS2exe)

spb3tst       = $(PBLASTSTdir)/$(sPBLAS3exe)
dpb3tst       = $(PBLASTSTdir)/$(dPBLAS3exe)
cpb3tst       = $(PBLASTSTdir)/$(cPBLAS3exe)
zpb3tst       = $(PBLASTSTdir)/$(zPBLAS3exe)

pbtcom        = pblastst.o PB_Cwarn.o PB_Cabort.o

spbtcom       = psblastst.o slamch.o $(pbtcom)
dpbtcom       = pdblastst.o dlamch.o $(pbtcom)
cpbtcom       = pcblastst.o slamch.o $(pbtcom)
zpbtcom       = pzblastst.o dlamch.o $(pbtcom)

spb1t         = psblas1tst.o $(spbtcom)
dpb1t         = pdblas1tst.o $(dpbtcom)
cpb1t         = pcblas1tst.o $(cpbtcom)
zpb1t         = pzblas1tst.o $(zpbtcom)

spb2t         = psblas2tst.o $(spbtcom)
dpb2t         = pdblas2tst.o $(dpbtcom)
cpb2t         = pcblas2tst.o $(cpbtcom)
zpb2t         = pzblas2tst.o $(zpbtcom)

spb3t         = psblas3tst.o $(spbtcom)
dpb3t         = pdblas3tst.o $(dpbtcom)
cpb3t         = pcblas3tst.o $(cpbtcom)
zpb3t         = pzblas3tst.o $(zpbtcom)

all : single double complex complex16

single:    PblasErrorHandler $(spb1tst) $(spb2tst) $(spb3tst)

double:    PblasErrorHandler $(dpb1tst) $(dpb2tst) $(dpb3tst)

complex:   PblasErrorHandler $(cpb1tst) $(cpb2tst) $(cpb3tst)

complex16: PblasErrorHandler $(zpb1tst) $(zpb2tst) $(zpb3tst)

PblasErrorHandler:
	rm -f PB_Cwarn.c  PB_Cwarn.o
	ln -s $(PBLASdir)/SRC/PTOOLS/PB_Cwarn.c  PB_Cwarn.c
	$(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas PB_Cwarn.c
	rm -f PB_Cabort.c PB_Cabort.o
	ln -s $(PBLASdir)/SRC/PTOOLS/PB_Cabort.c PB_Cabort.c
	$(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas PB_Cabort.c

$(PBLASTSTdir)/PSBLAS1TST.dat: PSBLAS1TST.dat
	cp PSBLAS1TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS1TST.dat: PDBLAS1TST.dat
	cp PDBLAS1TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS1TST.dat: PCBLAS1TST.dat
	cp PCBLAS1TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS1TST.dat: PZBLAS1TST.dat
	cp PZBLAS1TST.dat $(PBLASTSTdir)

$(spb1tst) : $(SCALAPACKLIB) $(spb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb1tst) $(spb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS1TST.dat
$(dpb1tst) : $(SCALAPACKLIB) $(dpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb1tst) $(dpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS1TST.dat
$(cpb1tst) : $(SCALAPACKLIB) $(cpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb1tst) $(cpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS1TST.dat
$(zpb1tst) : $(SCALAPACKLIB) $(zpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb1tst) $(zpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS1TST.dat

$(PBLASTSTdir)/PSBLAS2TST.dat: PSBLAS2TST.dat
	cp PSBLAS2TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS2TST.dat: PDBLAS2TST.dat
	cp PDBLAS2TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS2TST.dat: PCBLAS2TST.dat
	cp PCBLAS2TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS2TST.dat: PZBLAS2TST.dat
	cp PZBLAS2TST.dat $(PBLASTSTdir)

$(spb2tst) : $(SCALAPACKLIB) $(spb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb2tst) $(spb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS2TST.dat
$(dpb2tst) : $(SCALAPACKLIB) $(dpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb2tst) $(dpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS2TST.dat
$(cpb2tst) : $(SCALAPACKLIB) $(cpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb2tst) $(cpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS2TST.dat
$(zpb2tst) : $(SCALAPACKLIB) $(zpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb2tst) $(zpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS2TST.dat

$(PBLASTSTdir)/PSBLAS3TST.dat: PSBLAS3TST.dat
	cp PSBLAS3TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS3TST.dat: PDBLAS3TST.dat
	cp PDBLAS3TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS3TST.dat: PCBLAS3TST.dat
	cp PCBLAS3TST.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS3TST.dat: PZBLAS3TST.dat
	cp PZBLAS3TST.dat $(PBLASTSTdir)

$(spb3tst) : $(SCALAPACKLIB) $(spb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb3tst) $(spb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS3TST.dat
$(dpb3tst) : $(SCALAPACKLIB) $(dpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb3tst) $(dpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS3TST.dat
$(cpb3tst) : $(SCALAPACKLIB) $(cpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb3tst) $(cpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS3TST.dat
$(zpb3tst) : $(SCALAPACKLIB) $(zpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb3tst) $(zpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS3TST.dat

$(spb1t): $(FRC)
$(dpb1t): $(FRC)
$(cpb1t): $(FRC)
$(zpb1t): $(FRC)

$(spb2t): $(FRC)
$(dpb2t): $(FRC)
$(cpb2t): $(FRC)
$(zpb2t): $(FRC)

$(spb3t): $(FRC)
$(dpb3t): $(FRC)
$(cpb3t): $(FRC)
$(zpb3t): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

slamch.o:
	$(F77) -c $(NOOPT) slamch.f

dlamch.o:
	$(F77) -c $(NOOPT) dlamch.f

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

# .c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas $*.c

=== PBLAS/TIMING/Makefile ===
############################################################################
#
#  Program:         PBLAS -- (version 2.0)
#
#  Module:          Makefile
#
#  Purpose:         Timing Makefile
#
#  Creation date:   April 1, 1998
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

sPBLAS1exe    = xspblas1tim
dPBLAS1exe    = xdpblas1tim
cPBLAS1exe    = xcpblas1tim
zPBLAS1exe    = xzpblas1tim

sPBLAS2exe    = xspblas2tim
dPBLAS2exe    = xdpblas2tim
cPBLAS2exe    = xcpblas2tim
zPBLAS2exe    = xzpblas2tim

sPBLAS3exe    = xspblas3tim
dPBLAS3exe    = xdpblas3tim
cPBLAS3exe    = xcpblas3tim
zPBLAS3exe    = xzpblas3tim

spb1tim       = $(PBLASTSTdir)/$(sPBLAS1exe)
dpb1tim       = $(PBLASTSTdir)/$(dPBLAS1exe)
cpb1tim       = $(PBLASTSTdir)/$(cPBLAS1exe)
zpb1tim       = $(PBLASTSTdir)/$(zPBLAS1exe)

spb2tim       = $(PBLASTSTdir)/$(sPBLAS2exe)
dpb2tim       = $(PBLASTSTdir)/$(dPBLAS2exe)
cpb2tim       = $(PBLASTSTdir)/$(cPBLAS2exe)
zpb2tim       = $(PBLASTSTdir)/$(zPBLAS2exe)

spb3tim       = $(PBLASTSTdir)/$(sPBLAS3exe)
dpb3tim       = $(PBLASTSTdir)/$(dPBLAS3exe)
cpb3tim       = $(PBLASTSTdir)/$(cPBLAS3exe)
zpb3tim       = $(PBLASTSTdir)/$(zPBLAS3exe)

pbtcom        = pblastim.o PB_Cwarn.o PB_Cabort.o

spb1t         = psblas1tim.o psblastim.o $(pbtcom)
dpb1t         = pdblas1tim.o pdblastim.o $(pbtcom)
cpb1t         = pcblas1tim.o pcblastim.o $(pbtcom)
zpb1t         = pzblas1tim.o pzblastim.o $(pbtcom)

spb2t         = psblas2tim.o psblastim.o $(pbtcom)
dpb2t         = pdblas2tim.o pdblastim.o $(pbtcom)
cpb2t         = pcblas2tim.o pcblastim.o $(pbtcom)
zpb2t         = pzblas2tim.o pzblastim.o $(pbtcom)

spb3t         = psblas3tim.o psblastim.o $(pbtcom)
dpb3t         = pdblas3tim.o pdblastim.o $(pbtcom)
cpb3t         = pcblas3tim.o pcblastim.o $(pbtcom)
zpb3t         = pzblas3tim.o pzblastim.o $(pbtcom)

all : single double complex complex16

single:    PblasErrorHandler $(spb1tim) $(spb2tim) $(spb3tim)

double:    PblasErrorHandler $(dpb1tim) $(dpb2tim) $(dpb3tim)

complex:   PblasErrorHandler $(cpb1tim) $(cpb2tim) $(cpb3tim)

complex16: PblasErrorHandler $(zpb1tim) $(zpb2tim) $(zpb3tim)

PblasErrorHandler:
	rm -f PB_Cwarn.c  PB_Cwarn.o
	ln -s $(PBLASdir)/SRC/PTOOLS/PB_Cwarn.c  PB_Cwarn.c
	$(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas PB_Cwarn.c
	rm -f PB_Cabort.c PB_Cabort.o
	ln -s $(PBLASdir)/SRC/PTOOLS/PB_Cabort.c PB_Cabort.c
	$(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas PB_Cabort.c

$(PBLASTSTdir)/PSBLAS1TIM.dat: PSBLAS1TIM.dat
	cp PSBLAS1TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS1TIM.dat: PDBLAS1TIM.dat
	cp PDBLAS1TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS1TIM.dat: PCBLAS1TIM.dat
	cp PCBLAS1TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS1TIM.dat: PZBLAS1TIM.dat
	cp PZBLAS1TIM.dat $(PBLASTSTdir)

$(spb1tim) : $(SCALAPACKLIB) $(spb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb1tim) $(spb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS1TIM.dat
$(dpb1tim) : $(SCALAPACKLIB) $(dpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb1tim) $(dpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS1TIM.dat
$(cpb1tim) : $(SCALAPACKLIB) $(cpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb1tim) $(cpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS1TIM.dat
$(zpb1tim) : $(SCALAPACKLIB) $(zpb1t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb1tim) $(zpb1t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS1TIM.dat

$(PBLASTSTdir)/PSBLAS2TIM.dat: PSBLAS2TIM.dat
	cp PSBLAS2TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS2TIM.dat: PDBLAS2TIM.dat
	cp PDBLAS2TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS2TIM.dat: PCBLAS2TIM.dat
	cp PCBLAS2TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS2TIM.dat: PZBLAS2TIM.dat
	cp PZBLAS2TIM.dat $(PBLASTSTdir)

$(spb2tim) : $(SCALAPACKLIB) $(spb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb2tim) $(spb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS2TIM.dat
$(dpb2tim) : $(SCALAPACKLIB) $(dpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb2tim) $(dpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS2TIM.dat
$(cpb2tim) : $(SCALAPACKLIB) $(cpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb2tim) $(cpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS2TIM.dat
$(zpb2tim) : $(SCALAPACKLIB) $(zpb2t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb2tim) $(zpb2t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS2TIM.dat

$(PBLASTSTdir)/PSBLAS3TIM.dat: PSBLAS3TIM.dat
	cp PSBLAS3TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PDBLAS3TIM.dat: PDBLAS3TIM.dat
	cp PDBLAS3TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PCBLAS3TIM.dat: PCBLAS3TIM.dat
	cp PCBLAS3TIM.dat $(PBLASTSTdir)
$(PBLASTSTdir)/PZBLAS3TIM.dat: PZBLAS3TIM.dat
	cp PZBLAS3TIM.dat $(PBLASTSTdir)

$(spb3tim) : $(SCALAPACKLIB) $(spb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spb3tim) $(spb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PSBLAS3TIM.dat
$(dpb3tim) : $(SCALAPACKLIB) $(dpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpb3tim) $(dpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PDBLAS3TIM.dat
$(cpb3tim) : $(SCALAPACKLIB) $(cpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpb3tim) $(cpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PCBLAS3TIM.dat
$(zpb3tim) : $(SCALAPACKLIB) $(zpb3t)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpb3tim) $(zpb3t) $(LIBS)
	$(MAKE) $(PBLASTSTdir)/PZBLAS3TIM.dat

$(spb1t): $(FRC)
$(dpb1t): $(FRC)
$(cpb1t): $(FRC)
$(zpb1t): $(FRC)

$(spb2t): $(FRC)
$(dpb2t): $(FRC)
$(cpb2t): $(FRC)
$(zpb2t): $(FRC)

$(spb3t): $(FRC)
$(dpb3t): $(FRC)
$(cpb3t): $(FRC)
$(zpb3t): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

# .c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) -DTestingPblas $*.c

=== REDIST/SRC/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK Redistrib
#
#  Module:          Makefile
#
#  Purpose:         Redistribution Sources Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

#######################################################################
#  This is the makefile to create a library for redistribution.
#  The files are organized as follows:
#       ALLAUX -- Auxiliary routines called from all precisions
#       IMRSRC -- Integer REDIST routines
#       SMRSRC -- Single precision real REDIST routines
#       CMRSRC -- Single precision complex REDIST routines
#       DMRSRC -- Double precision real REDIST routines
#       ZMRSRC -- Double precision complex REDIST routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ARCH, ARCHFLAGS, RANLIB,
#  CC and CFLAGS definitions in ../../SLmake.inc to match your library
#  archiver, compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is defined by $(SCALAPACKLIB) in
#  ../../SLmake.inc and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

ALLAUX = \
   pgemraux.o

IMRSRC = \
   pigemr.o pigemr2.o pitrmr.o pitrmr2.o 

SMRSRC = \
   psgemr.o psgemr2.o pstrmr.o pstrmr2.o 

CMRSRC = \
   pcgemr.o pcgemr2.o pctrmr.o pctrmr2.o 

DMRSRC = \
   pdgemr.o pdgemr2.o pdtrmr.o pdtrmr2.o 

ZMRSRC = \
   pzgemr.o pzgemr2.o pztrmr.o pztrmr2.o 

all: integer single complex double complex16
lib: all

integer: $(IMRSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(IMRSRC) $(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

single: $(SMRSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(SMRSRC) $(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex: $(CMRSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(CMRSRC) $(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

double: $(DMRSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(DMRSRC) $(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex16: $(ZMRSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(ZMRSRC) $(ALLAUX)
	$(RANLIB) $(SCALAPACKLIB)

$(ALLAUX): $(FRC)
$(IMRSRC): $(FRC)
$(SMRSRC): $(FRC)
$(CMRSRC): $(FRC)
$(DMRSRC): $(FRC)
$(ZMRSRC): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

.c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) $*.c

=== REDIST/TESTING/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Redistribution Testing Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

igemrexe = $(REDISTTSTdir)/xigemr
sgemrexe = $(REDISTTSTdir)/xsgemr
dgemrexe = $(REDISTTSTdir)/xdgemr
cgemrexe = $(REDISTTSTdir)/xcgemr
zgemrexe = $(REDISTTSTdir)/xzgemr
itrmrexe = $(REDISTTSTdir)/xitrmr
strmrexe = $(REDISTTSTdir)/xstrmr
dtrmrexe = $(REDISTTSTdir)/xdtrmr
ctrmrexe = $(REDISTTSTdir)/xctrmr
ztrmrexe = $(REDISTTSTdir)/xztrmr

igemr = pigemrdrv.o
sgemr = psgemrdrv.o
dgemr = pdgemrdrv.o
cgemr = pcgemrdrv.o
zgemr = pzgemrdrv.o

itrmr = pitrmrdrv.o
strmr = pstrmrdrv.o
dtrmr = pdtrmrdrv.o
ctrmr = pctrmrdrv.o
ztrmr = pztrmrdrv.o

all: exe
exe: integer single double complex complex16

integer: $(igemrexe) $(itrmrexe)

single: $(sgemrexe) $(strmrexe) 

double: $(dgemrexe) $(dtrmrexe)

complex: $(cgemrexe) $(ctrmrexe)

complex16: $(zgemrexe) $(ztrmrexe)

$(TESTINGdir)/GEMR2D.dat: GEMR2D.dat
	cp GEMR2D.dat $(TESTINGdir)

$(igemrexe): $(SCALAPACKLIB) $(igemr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(igemrexe) $(igemr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/GEMR2D.dat

$(sgemrexe): $(SCALAPACKLIB) $(sgemr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(sgemrexe) $(sgemr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/GEMR2D.dat

$(dgemrexe): $(SCALAPACKLIB) $(dgemr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(dgemrexe) $(dgemr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/GEMR2D.dat

$(cgemrexe): $(SCALAPACKLIB) $(cgemr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(cgemrexe) $(cgemr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/GEMR2D.dat

$(zgemrexe): $(SCALAPACKLIB) $(zgemr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(zgemrexe) $(zgemr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/GEMR2D.dat

$(TESTINGdir)/TRMR2D.dat: TRMR2D.dat
	cp TRMR2D.dat $(TESTINGdir)

$(itrmrexe): $(SCALAPACKLIB) $(itrmr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(itrmrexe) $(itrmr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/TRMR2D.dat

$(strmrexe): $(SCALAPACKLIB) $(strmr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(strmrexe) $(strmr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/TRMR2D.dat

$(dtrmrexe): $(SCALAPACKLIB) $(dtrmr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(dtrmrexe) $(dtrmr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/TRMR2D.dat

$(ctrmrexe): $(SCALAPACKLIB) $(ctrmr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(ctrmrexe) $(ctrmr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/TRMR2D.dat

$(ztrmrexe): $(SCALAPACKLIB) $(ztrmr)
	$(CCLOADER) $(CCLOADFLAGS) -o $(ztrmrexe) $(ztrmr) $(PRLIBS)
	$(MAKE) $(TESTINGdir)/TRMR2D.dat

$(igemr): $(FRC)
$(sgemr): $(FRC)
$(dgemr): $(FRC)
$(cgemr): $(FRC)
$(zgemr): $(FRC)

$(itrmr): $(FRC)
$(strmr): $(FRC)
$(dtrmr): $(FRC)
$(ctrmr): $(FRC)
$(ztrmr): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

.c.o : ; $(CC) -c $(CCFLAGS) $(CDEFS) $*.c

=== TESTING/EIG/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Eigenroutine Testing Makefile
#
#  Creation date:   February 20, 2000
#
#  Modified:
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

shrdexe = $(TESTINGdir)/xshrd
dhrdexe = $(TESTINGdir)/xdhrd
chrdexe = $(TESTINGdir)/xchrd
zhrdexe = $(TESTINGdir)/xzhrd

strdexe = $(TESTINGdir)/xstrd
dtrdexe = $(TESTINGdir)/xdtrd
ctrdexe = $(TESTINGdir)/xctrd
ztrdexe = $(TESTINGdir)/xztrd

sbrdexe = $(TESTINGdir)/xsbrd
dbrdexe = $(TESTINGdir)/xdbrd
cbrdexe = $(TESTINGdir)/xcbrd
zbrdexe = $(TESTINGdir)/xzbrd


ssepexe = $(TESTINGdir)/xssep
dsepexe = $(TESTINGdir)/xdsep
csepexe = $(TESTINGdir)/xcsep
zsepexe = $(TESTINGdir)/xzsep

sgsepexe = $(TESTINGdir)/xsgsep
dgsepexe = $(TESTINGdir)/xdgsep
cgsepexe = $(TESTINGdir)/xcgsep
zgsepexe = $(TESTINGdir)/xzgsep

ssvdexe = $(TESTINGdir)/xssvd
dsvdexe = $(TESTINGdir)/xdsvd

snepexe = $(TESTINGdir)/xsnep
dnepexe = $(TESTINGdir)/xdnep
cnepexe = $(TESTINGdir)/xcnep
znepexe = $(TESTINGdir)/xznep

cevcexe = $(TESTINGdir)/xcevc
zevcexe = $(TESTINGdir)/xzevc

smatgen = psmatgen.o pmatgeninc.o
dmatgen = pdmatgen.o pmatgeninc.o
cmatgen = pcmatgen.o pmatgeninc.o
zmatgen = pzmatgen.o pmatgeninc.o

sbrd = psbrddriver.o psbrdinfo.o psgebdrv.o pslafchk.o $(smatgen)
dbrd = pdbrddriver.o pdbrdinfo.o pdgebdrv.o pdlafchk.o $(dmatgen)
cbrd = pcbrddriver.o pcbrdinfo.o pcgebdrv.o pclafchk.o $(cmatgen)
zbrd = pzbrddriver.o pzbrdinfo.o pzgebdrv.o pzlafchk.o $(zmatgen)

shrd = pshrddriver.o pshrdinfo.o psgehdrv.o pslafchk.o $(smatgen)
dhrd = pdhrddriver.o pdhrdinfo.o pdgehdrv.o pdlafchk.o $(dmatgen)
chrd = pchrddriver.o pchrdinfo.o pcgehdrv.o pclafchk.o $(cmatgen)
zhrd = pzhrddriver.o pzhrdinfo.o pzgehdrv.o pzlafchk.o $(zmatgen)

strd = pstrddriver.o psttrdtester.o pslatran.o pstrdinfo.o pssytdrv.o \
       pslafchk.o xpjlaenv.o $(smatgen)
dtrd = pdtrddriver.o pdttrdtester.o pdlatran.o pdtrdinfo.o pdsytdrv.o \
       pdlafchk.o xpjlaenv.o $(dmatgen)
ctrd = pctrddriver.o pcttrdtester.o pclatran.o pctrdinfo.o pchetdrv.o \
       pclafchk.o xpjlaenv.o $(cmatgen)
ztrd = pztrddriver.o pzttrdtester.o pzlatran.o pztrdinfo.o pzhetdrv.o \
       pzlafchk.o xpjlaenv.o $(zmatgen)

ssvd =  pssvddriver.o pslagge.o pssvdchk.o pssvdcmp.o pssvdtst.o $(smatgen)
dsvd =  pdsvddriver.o pdlagge.o pdsvdchk.o pdsvdcmp.o pdsvdtst.o $(dmatgen)

ssep =  psseptst.o pssepsubtst.o pssepchk.o pssepqtq.o pslagsy.o \
        pslatms.o  pslasizesep.o pslasizesyevx.o pssepdriver.o \
        pssepreq.o pssepinfo.o pslasizesyev.o \
        pssqpsubtst.o pslasizesqp.o pssdpsubtst.o $(smatgen)
dsep =  pdseptst.o pdsepsubtst.o pdsepchk.o pdsepqtq.o pdlagsy.o \
        pdlatms.o  pdlasizesep.o pdlasizesyevx.o pdsepdriver.o \
        pdsepreq.o pdsepinfo.o pdlasizesyev.o \
        pdsqpsubtst.o pdlasizesqp.o pdsdpsubtst.o $(dmatgen)
csep =  pcseptst.o pcsepsubtst.o pcsepchk.o pcsepqtq.o pclagsy.o \
        pclatms.o  pclasizesep.o pclasizeheevx.o pcsepdriver.o \
        pcsepreq.o pssepinfo.o pcsdpsubtst.o $(cmatgen)
zsep =  pzseptst.o pzsepsubtst.o pzsepchk.o pzsepqtq.o pzlagsy.o \
        pzlatms.o  pzlasizesep.o pzlasizeheevx.o pzsepdriver.o \
        pzsepreq.o pdsepinfo.o pzsdpsubtst.o $(zmatgen)

sgsep =  psgseptst.o psgsepsubtst.o psgsepchk.o pslagsy.o \
         pslatms.o pslasizesyevx.o pslasizegsep.o pslasizesep.o \
         psgsepdriver.o psgsepreq.o pssepinfo.o $(smatgen)
dgsep =  pdgseptst.o pdgsepsubtst.o pdgsepchk.o pdlagsy.o \
         pdlatms.o pdlasizesyevx.o pdlasizegsep.o pdlasizesep.o \
         pdgsepdriver.o pdgsepreq.o pdsepinfo.o $(dmatgen)
cgsep =  pcgseptst.o pcgsepsubtst.o pcgsepchk.o pclagsy.o \
         pclatms.o pclasizegsep.o pclasizeheevx.o pclasizesep.o \
         pcgsepdriver.o pcgsepreq.o pssepinfo.o $(cmatgen)
zgsep =  pzgseptst.o pzgsepsubtst.o pzgsepchk.o pzlagsy.o \
         pzlatms.o pzlasizegsep.o pzlasizeheevx.o pzlasizesep.o \
         pzgsepdriver.o pzgsepreq.o pdsepinfo.o $(zmatgen)

snep =  psnepdriver.o psnepinfo.o psnepfchk.o $(smatgen)
dnep =  pdnepdriver.o pdnepinfo.o pdnepfchk.o $(dmatgen)
cnep =  pcnepdriver.o pcnepinfo.o pcnepfchk.o $(cmatgen)
znep =  pznepdriver.o pznepinfo.o pznepfchk.o $(zmatgen)

cevc =  pcevcdriver.o pcevcinfo.o pcget22.o $(cmatgen)
zevc =  pzevcdriver.o pzevcinfo.o pzget22.o $(zmatgen)

all : single double complex complex16

single:    $(shrdexe) $(strdexe) $(sbrdexe) $(ssepexe) $(sgsepexe) \
           $(snepexe) $(ssvdexe)
double:    $(dhrdexe) $(dtrdexe) $(dbrdexe) $(dsepexe) $(dgsepexe) \
           $(dnepexe) $(dsvdexe)
complex:   $(chrdexe) $(ctrdexe) $(cbrdexe) $(csepexe) $(cgsepexe) \
           $(cnepexe) $(cevcexe)
complex16: $(zhrdexe) $(ztrdexe) $(zbrdexe) $(zsepexe) $(zgsepexe) \
           $(znepexe) $(zevcexe)

$(TESTINGdir)/BRD.dat: ../BRD.dat
	cp ../BRD.dat $(TESTINGdir)

$(sbrdexe) : $(SCALAPACKLIB) $(sbrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sbrdexe) $(sbrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/BRD.dat
$(dbrdexe) : $(SCALAPACKLIB) $(dbrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dbrdexe) $(dbrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/BRD.dat
$(cbrdexe) : $(SCALAPACKLIB) $(cbrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cbrdexe) $(cbrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/BRD.dat
$(zbrdexe) : $(SCALAPACKLIB) $(zbrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zbrdexe) $(zbrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/BRD.dat

$(TESTINGdir)/HRD.dat: ../HRD.dat
	cp ../HRD.dat $(TESTINGdir)

$(shrdexe) : $(SCALAPACKLIB) $(shrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(shrdexe) $(shrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/HRD.dat
$(dhrdexe) : $(SCALAPACKLIB) $(dhrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dhrdexe) $(dhrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/HRD.dat
$(chrdexe) : $(SCALAPACKLIB) $(chrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(chrdexe) $(chrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/HRD.dat
$(zhrdexe) : $(SCALAPACKLIB) $(zhrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zhrdexe) $(zhrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/HRD.dat

$(TESTINGdir)/TRD.dat: ../TRD.dat
	cp ../TRD.dat $(TESTINGdir)

$(strdexe) : $(SCALAPACKLIB) $(strd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(strdexe) $(strd) $(LIBS)
	$(MAKE) $(TESTINGdir)/TRD.dat
$(dtrdexe) : $(SCALAPACKLIB) $(dtrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dtrdexe) $(dtrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/TRD.dat
$(ctrdexe) : $(SCALAPACKLIB) $(ctrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ctrdexe) $(ctrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/TRD.dat
$(ztrdexe) : $(SCALAPACKLIB) $(ztrd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ztrdexe) $(ztrd) $(LIBS)
	$(MAKE) $(TESTINGdir)/TRD.dat


$(TESTINGdir)/SVD.dat: ../SVD.dat
	cp ../SVD.dat $(TESTINGdir)

$(ssvdexe) : $(SCALAPACKLIB) $(ssvd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ssvdexe) $(ssvd) $(RLIBS)
	$(MAKE) $(TESTINGdir)/SVD.dat
$(dsvdexe) : $(SCALAPACKLIB) $(dsvd)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dsvdexe) $(dsvd) $(RLIBS)
	$(MAKE) $(TESTINGdir)/SVD.dat

$(TESTINGdir)/SEP.dat: ../SEP.dat
	cp ../SEP.dat $(TESTINGdir)

$(ssepexe) : $(SCALAPACKLIB) $(ssep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ssepexe) $(ssep) $(RLIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(dsepexe) : $(SCALAPACKLIB) $(dsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dsepexe) $(dsep) $(RLIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(csepexe) : $(SCALAPACKLIB) $(csep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(csepexe) $(csep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(zsepexe) : $(SCALAPACKLIB) $(zsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zsepexe) $(zsep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat

$(sgsepexe) : $(SCALAPACKLIB) $(sgsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sgsepexe) $(sgsep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(dgsepexe) : $(SCALAPACKLIB) $(dgsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dgsepexe) $(dgsep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(cgsepexe) : $(SCALAPACKLIB) $(cgsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cgsepexe) $(cgsep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat
$(zgsepexe) : $(SCALAPACKLIB) $(zgsep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zgsepexe) $(zgsep) $(LIBS)
	$(MAKE) $(TESTINGdir)/SEP.dat

$(TESTINGdir)/NEP.dat: ../NEP.dat
	cp ../NEP.dat $(TESTINGdir)

$(snepexe) : $(SCALAPACKLIB) $(snep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(snepexe) $(snep) $(LIBS)
	$(MAKE) $(TESTINGdir)/NEP.dat
$(dnepexe) : $(SCALAPACKLIB) $(dnep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dnepexe) $(dnep) $(LIBS)
	$(MAKE) $(TESTINGdir)/NEP.dat
$(cnepexe) : $(SCALAPACKLIB) $(cnep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cnepexe) $(cnep) $(LIBS)
	$(MAKE) $(TESTINGdir)/NEP.dat
$(znepexe) : $(SCALAPACKLIB) $(znep)
	$(F77LOADER) $(F77LOADFLAGS) -o $(znepexe) $(znep) $(LIBS)
	$(MAKE) $(TESTINGdir)/NEP.dat

$(TESTINGdir)/EVC.dat: ../EVC.dat
	cp ../EVC.dat $(TESTINGdir)

$(cevcexe) : $(SCALAPACKLIB) $(cevc)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cevcexe) $(cevc) $(LIBS)
	$(MAKE) $(TESTINGdir)/EVC.dat
$(zevcexe) : $(SCALAPACKLIB) $(zevc)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zevcexe) $(zevc) $(LIBS)
	$(MAKE) $(TESTINGdir)/EVC.dat

$(sbrd): $(FRC)
$(dbrd): $(FRC)
$(cbrd): $(FRC)
$(zbrd): $(FRC)

$(shrd): $(FRC)
$(dhrd): $(FRC)
$(chrd): $(FRC)
$(zhrd): $(FRC)

$(strd): $(FRC)
$(dtrd): $(FRC)
$(ctrd): $(FRC)
$(ztrd): $(FRC)

$(ssvd): $(FRC)
$(dsvd): $(FRC)

$(ssep): $(FRC)
$(dsep): $(FRC)
$(csep): $(FRC)
$(zsep): $(FRC)

$(sgsep): $(FRC)
$(dgsep): $(FRC)
$(cgsep): $(FRC)
$(zgsep): $(FRC)

$(snep): $(FRC)
$(dnep): $(FRC)
$(cnep): $(FRC)
$(znep): $(FRC)

$(cevc): $(FRC)
$(zevc): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

psbrddriver.o: psbrddriver.f
	$(F77) $(DRVOPTS) -c $<
pdbrddriver.o: pdbrddriver.f
	$(F77) $(DRVOPTS) -c $<
pcbrddriver.o: pcbrddriver.f
	$(F77) $(DRVOPTS) -c $<
pzbrddriver.o: pzbrddriver.f
	$(F77) $(DRVOPTS) -c $<

pshrddriver.o: pshrddriver.f
	$(F77) $(DRVOPTS) -c $<
pdhrddriver.o: pdhrddriver.f
	$(F77) $(DRVOPTS) -c $<
pchrddriver.o: pchrddriver.f
	$(F77) $(DRVOPTS) -c $<
pzhrddriver.o: pzhrddriver.f
	$(F77) $(DRVOPTS) -c $<

pstrddriver.o: pstrddriver.f
	$(F77) $(DRVOPTS) -c $<
pdtrddriver.o: pdtrddriver.f
	$(F77) $(DRVOPTS) -c $<
pctrddriver.o: pctrddriver.f
	$(F77) $(DRVOPTS) -c $<
pztrddriver.o: pztrddriver.f
	$(F77) $(DRVOPTS) -c $<

pssvddriver.o: pssvddriver.f
	$(F77) $(DRVOPTS) -c $<
pdsvddriver.o: pdsvddriver.f
	$(F77) $(DRVOPTS) -c $<

pssepdriver.o: pssepdriver.f
	$(F77) $(DRVOPTS) -c $<
pdsepdriver.o: pdsepdriver.f
	$(F77) $(DRVOPTS) -c $<
pcsepdriver.o: pcsepdriver.f
	$(F77) $(DRVOPTS) -c $<
pzsepdriver.o: pzsepdriver.f
	$(F77) $(DRVOPTS) -c $<

psgsepdriver.o: psgsepdriver.f
	$(F77) $(DRVOPTS) -c $<
pdgsepdriver.o: pdgsepdriver.f
	$(F77) $(DRVOPTS) -c $<
pcgsepdriver.o: pcgsepdriver.f
	$(F77) $(DRVOPTS) -c $<
pzgsepdriver.o: pzgsepdriver.f
	$(F77) $(DRVOPTS) -c $<

psnepdriver.o: psnepdriver.f
	$(F77) $(DRVOPTS) -c $<
pdnepdriver.o: pdnepdriver.f
	$(F77) $(DRVOPTS) -c $<
pcnepdriver.o: pcnepdriver.f
	$(F77) $(DRVOPTS) -c $<
pznepdriver.o: pznepdriver.f
	$(F77) $(DRVOPTS) -c $<

pcevcdriver.o: pcevcdriver.f
	$(F77) $(DRVOPTS) -c $<
pzevcdriver.o: pzevcdriver.f
	$(F77) $(DRVOPTS) -c $<

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

=== TESTING/LIN/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Linear Equations Testing Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

sluexe = $(TESTINGdir)/xslu
dluexe = $(TESTINGdir)/xdlu
cluexe = $(TESTINGdir)/xclu
zluexe = $(TESTINGdir)/xzlu

sdbluexe = $(TESTINGdir)/xsdblu
ddbluexe = $(TESTINGdir)/xddblu
cdbluexe = $(TESTINGdir)/xcdblu
zdbluexe = $(TESTINGdir)/xzdblu

sdtluexe = $(TESTINGdir)/xsdtlu
ddtluexe = $(TESTINGdir)/xddtlu
cdtluexe = $(TESTINGdir)/xcdtlu
zdtluexe = $(TESTINGdir)/xzdtlu

sgbluexe = $(TESTINGdir)/xsgblu
dgbluexe = $(TESTINGdir)/xdgblu
cgbluexe = $(TESTINGdir)/xcgblu
zgbluexe = $(TESTINGdir)/xzgblu

slltexe = $(TESTINGdir)/xsllt
dlltexe = $(TESTINGdir)/xdllt
clltexe = $(TESTINGdir)/xcllt
zlltexe = $(TESTINGdir)/xzllt

spblltexe = $(TESTINGdir)/xspbllt
dpblltexe = $(TESTINGdir)/xdpbllt
cpblltexe = $(TESTINGdir)/xcpbllt
zpblltexe = $(TESTINGdir)/xzpbllt

sptlltexe = $(TESTINGdir)/xsptllt
dptlltexe = $(TESTINGdir)/xdptllt
cptlltexe = $(TESTINGdir)/xcptllt
zptlltexe = $(TESTINGdir)/xzptllt

sinvexe = $(TESTINGdir)/xsinv
dinvexe = $(TESTINGdir)/xdinv
cinvexe = $(TESTINGdir)/xcinv
zinvexe = $(TESTINGdir)/xzinv

sqrexe = $(TESTINGdir)/xsqr
dqrexe = $(TESTINGdir)/xdqr
cqrexe = $(TESTINGdir)/xcqr
zqrexe = $(TESTINGdir)/xzqr

slsexe = $(TESTINGdir)/xsls
dlsexe = $(TESTINGdir)/xdls
clsexe = $(TESTINGdir)/xcls
zlsexe = $(TESTINGdir)/xzls

smatgen = psmatgen.o pmatgeninc.o
dmatgen = pdmatgen.o pmatgeninc.o
cmatgen = pcmatgen.o pmatgeninc.o
zmatgen = pzmatgen.o pmatgeninc.o

slinchk = pslaschk.o pslafchk.o
dlinchk = pdlaschk.o pdlafchk.o
clinchk = pclaschk.o pclafchk.o
zlinchk = pzlaschk.o pzlafchk.o

slu = psludriver.o psluinfo.o psgetrrv.o $(smatgen) $(slinchk)
dlu = pdludriver.o pdluinfo.o pdgetrrv.o $(dmatgen) $(dlinchk)
clu = pcludriver.o pcluinfo.o pcgetrrv.o $(cmatgen) $(clinchk)
zlu = pzludriver.o pzluinfo.o pzgetrrv.o $(zmatgen) $(zlinchk)

sdblu = psdbdriver.o psdbinfo.o psdblaschk.o psdbmv1.o psbmatgen.o $(smatgen)
ddblu = pddbdriver.o pddbinfo.o pddblaschk.o pddbmv1.o pdbmatgen.o $(dmatgen)
cdblu = pcdbdriver.o pcdbinfo.o pcdblaschk.o pcdbmv1.o pcbmatgen.o $(cmatgen)
zdblu = pzdbdriver.o pzdbinfo.o pzdblaschk.o pzdbmv1.o pzbmatgen.o $(zmatgen)

sdtlu = psdtdriver.o psdtinfo.o psdtlaschk.o psdbmv1.o psbmatgen.o $(smatgen)
ddtlu = pddtdriver.o pddtinfo.o pddtlaschk.o pddbmv1.o pdbmatgen.o $(dmatgen)
cdtlu = pcdtdriver.o pcdtinfo.o pcdtlaschk.o pcdbmv1.o pcbmatgen.o $(cmatgen)
zdtlu = pzdtdriver.o pzdtinfo.o pzdtlaschk.o pzdbmv1.o pzbmatgen.o $(zmatgen)

sgblu = psgbdriver.o psgbinfo.o psdblaschk.o psgbmv1.o psbmatgen.o $(smatgen)
dgblu = pdgbdriver.o pdgbinfo.o pddblaschk.o pdgbmv1.o pdbmatgen.o $(dmatgen)
cgblu = pcgbdriver.o pcgbinfo.o pcdblaschk.o pcgbmv1.o pcbmatgen.o $(cmatgen)
zgblu = pzgbdriver.o pzgbinfo.o pzdblaschk.o pzgbmv1.o pzbmatgen.o $(zmatgen)


sllt = pslltdriver.o pslltinfo.o pspotrrv.o $(smatgen) $(slinchk)
dllt = pdlltdriver.o pdlltinfo.o pdpotrrv.o $(dmatgen) $(dlinchk)
cllt = pclltdriver.o pclltinfo.o pcpotrrv.o $(cmatgen) $(clinchk)
zllt = pzlltdriver.o pzlltinfo.o pzpotrrv.o $(zmatgen) $(zlinchk)

spbllt = pspbdriver.o pspbinfo.o pspblaschk.o pspbmv1.o psbmatgen.o $(smatgen)
dpbllt = pdpbdriver.o pdpbinfo.o pdpblaschk.o pdpbmv1.o pdbmatgen.o $(dmatgen)
cpbllt = pcpbdriver.o pcpbinfo.o pcpblaschk.o pcpbmv1.o pcbmatgen.o $(cmatgen)
zpbllt = pzpbdriver.o pzpbinfo.o pzpblaschk.o pzpbmv1.o pzbmatgen.o $(zmatgen)

sptllt = psptdriver.o psptinfo.o psptlaschk.o pspbmv1.o psbmatgen.o $(smatgen)
dptllt = pdptdriver.o pdptinfo.o pdptlaschk.o pdpbmv1.o pdbmatgen.o $(dmatgen)
cptllt = pcptdriver.o pcptinfo.o pcptlaschk.o pcpbmv1.o pcbmatgen.o $(cmatgen)
zptllt = pzptdriver.o pzptinfo.o pzptlaschk.o pzpbmv1.o pzbmatgen.o $(zmatgen)

sinv = psinvdriver.o psinvinfo.o psinvchk.o $(smatgen)
dinv = pdinvdriver.o pdinvinfo.o pdinvchk.o $(dmatgen)
cinv = pcinvdriver.o pcinvinfo.o pcinvchk.o $(cmatgen)
zinv = pzinvdriver.o pzinvinfo.o pzinvchk.o $(zmatgen)

sqr = psqrdriver.o psqrinfo.o psgeqrrv.o psgeqlrv.o psgelqrv.o \
      psgerqrv.o   pstzrzrv.o pslafchk.o $(smatgen)
dqr = pdqrdriver.o pdqrinfo.o pdgeqrrv.o pdgeqlrv.o pdgelqrv.o \
      pdgerqrv.o   pdtzrzrv.o pdlafchk.o $(dmatgen)
cqr = pcqrdriver.o pcqrinfo.o pcgeqrrv.o pcgeqlrv.o pcgelqrv.o \
      pcgerqrv.o   pctzrzrv.o pclafchk.o $(cmatgen)
zqr = pzqrdriver.o pzqrinfo.o pzgeqrrv.o pzgeqlrv.o pzgelqrv.o \
      pzgerqrv.o   pztzrzrv.o pzlafchk.o $(zmatgen)

sls = pslsdriver.o pslsinfo.o psqrt13.o psqrt14.o psqrt16.o \
      psqrt17.o $(smatgen)
dls = pdlsdriver.o pdlsinfo.o pdqrt13.o pdqrt14.o pdqrt16.o \
      pdqrt17.o $(dmatgen)
cls = pclsdriver.o pclsinfo.o pcqrt13.o pcqrt14.o pcqrt16.o \
      pcqrt17.o $(cmatgen)
zls = pzlsdriver.o pzlsinfo.o pzqrt13.o pzqrt14.o pzqrt16.o \
      pzqrt17.o $(zmatgen)

all : single double complex complex16

single: $(sluexe) $(sdbluexe) $(sdtluexe) $(sgbluexe) $(slltexe) \
        $(spblltexe) $(sptlltexe) $(sinvexe) $(sqrexe) $(slsexe)

double: $(dluexe) $(ddbluexe) $(ddtluexe) $(dgbluexe) $(dlltexe) \
        $(dpblltexe) $(dptlltexe) $(dinvexe) $(dqrexe) $(dlsexe)

complex: $(cluexe) $(cdbluexe) $(cdtluexe) $(cgbluexe) $(clltexe) \
         $(cpblltexe) $(cptlltexe) $(cinvexe) $(cqrexe) $(clsexe)

complex16: $(zluexe) $(zdbluexe) $(zdtluexe) $(zgbluexe) $(zlltexe) \
           $(zpblltexe) $(zptlltexe) $(zinvexe) $(zqrexe) $(zlsexe)

$(TESTINGdir)/LU.dat: ../LU.dat
	cp ../LU.dat $(TESTINGdir)

$(sluexe): $(SCALAPACKLIB) $(slu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sluexe) $(slu) $(LIBS)
	$(MAKE) $(TESTINGdir)/LU.dat
$(dluexe): $(SCALAPACKLIB) $(dlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dluexe) $(dlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/LU.dat
$(cluexe): $(SCALAPACKLIB) $(clu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cluexe) $(clu) $(LIBS)
	$(MAKE) $(TESTINGdir)/LU.dat
$(zluexe): $(SCALAPACKLIB) $(zlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zluexe) $(zlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/LU.dat

$(TESTINGdir)/BLU.dat: ../BLU.dat
	cp ../BLU.dat $(TESTINGdir)

$(sdbluexe): $(SCALAPACKLIB) $(sdblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sdbluexe) $(sdblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(ddbluexe): $(SCALAPACKLIB) $(ddblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ddbluexe) $(ddblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(cdbluexe): $(SCALAPACKLIB) $(cdblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cdbluexe) $(cdblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(zdbluexe): $(SCALAPACKLIB) $(zdblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zdbluexe) $(zdblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat

$(sdtluexe): $(SCALAPACKLIB) $(sdtlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sdtluexe) $(sdtlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(ddtluexe): $(SCALAPACKLIB) $(ddtlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(ddtluexe) $(ddtlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(cdtluexe): $(SCALAPACKLIB) $(cdtlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cdtluexe) $(cdtlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(zdtluexe): $(SCALAPACKLIB) $(zdtlu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zdtluexe) $(zdtlu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat

$(sgbluexe): $(SCALAPACKLIB) $(sgblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sgbluexe) $(sgblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(dgbluexe): $(SCALAPACKLIB) $(dgblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dgbluexe) $(dgblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(cgbluexe): $(SCALAPACKLIB) $(cgblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cgbluexe) $(cgblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat
$(zgbluexe): $(SCALAPACKLIB) $(zgblu)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zgbluexe) $(zgblu) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLU.dat


$(TESTINGdir)/LLT.dat: ../LLT.dat
	cp ../LLT.dat $(TESTINGdir)

$(slltexe): $(SCALAPACKLIB) $(sllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(slltexe) $(sllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/LLT.dat
$(dlltexe): $(SCALAPACKLIB) $(dllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dlltexe) $(dllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/LLT.dat
$(clltexe): $(SCALAPACKLIB) $(cllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(clltexe) $(cllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/LLT.dat
$(zlltexe): $(SCALAPACKLIB) $(zllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zlltexe) $(zllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/LLT.dat

$(TESTINGdir)/BLLT.dat: ../BLLT.dat
	cp ../BLLT.dat $(TESTINGdir)

$(spblltexe): $(SCALAPACKLIB) $(spbllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(spblltexe) $(spbllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(dpblltexe): $(SCALAPACKLIB) $(dpbllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dpblltexe) $(dpbllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(cpblltexe): $(SCALAPACKLIB) $(cpbllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cpblltexe) $(cpbllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(zpblltexe): $(SCALAPACKLIB) $(zpbllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zpblltexe) $(zpbllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat

$(sptlltexe): $(SCALAPACKLIB) $(sptllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sptlltexe) $(sptllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(dptlltexe): $(SCALAPACKLIB) $(dptllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dptlltexe) $(dptllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(cptlltexe): $(SCALAPACKLIB) $(cptllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cptlltexe) $(cptllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat
$(zptlltexe): $(SCALAPACKLIB) $(zptllt)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zptlltexe) $(zptllt) $(LIBS)
	$(MAKE) $(TESTINGdir)/BLLT.dat

$(TESTINGdir)/INV.dat: ../INV.dat
	cp ../INV.dat $(TESTINGdir)

$(sinvexe): $(SCALAPACKLIB) $(sinv)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sinvexe) $(sinv) $(LIBS)
	$(MAKE) $(TESTINGdir)/INV.dat
$(dinvexe): $(SCALAPACKLIB) $(dinv)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dinvexe) $(dinv) $(LIBS)
	$(MAKE) $(TESTINGdir)/INV.dat
$(cinvexe): $(SCALAPACKLIB) $(cinv)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cinvexe) $(cinv) $(LIBS)
	$(MAKE) $(TESTINGdir)/INV.dat
$(zinvexe): $(SCALAPACKLIB) $(zinv)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zinvexe) $(zinv) $(LIBS)
	$(MAKE) $(TESTINGdir)/INV.dat

$(TESTINGdir)/QR.dat: ../QR.dat
	cp ../QR.dat $(TESTINGdir)

$(sqrexe): $(SCALAPACKLIB) $(sqr)
	$(F77LOADER) $(F77LOADFLAGS) -o $(sqrexe) $(sqr) $(LIBS)
	$(MAKE) $(TESTINGdir)/QR.dat
$(dqrexe): $(SCALAPACKLIB) $(dqr)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dqrexe) $(dqr) $(LIBS)
	$(MAKE) $(TESTINGdir)/QR.dat
$(cqrexe): $(SCALAPACKLIB) $(cqr)
	$(F77LOADER) $(F77LOADFLAGS) -o $(cqrexe) $(cqr) $(LIBS)
	$(MAKE) $(TESTINGdir)/QR.dat
$(zqrexe): $(SCALAPACKLIB) $(zqr)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zqrexe) $(zqr) $(LIBS)
	$(MAKE) $(TESTINGdir)/QR.dat

$(TESTINGdir)/LS.dat: ../LS.dat
	cp ../LS.dat $(TESTINGdir)

$(slsexe): $(SCALAPACKLIB) $(sls)
	$(F77LOADER) $(F77LOADFLAGS) -o $(slsexe) $(sls) $(LIBS)
	$(MAKE) $(TESTINGdir)/LS.dat
$(dlsexe): $(SCALAPACKLIB) $(dls)
	$(F77LOADER) $(F77LOADFLAGS) -o $(dlsexe) $(dls) $(LIBS)
	$(MAKE) $(TESTINGdir)/LS.dat
$(clsexe): $(SCALAPACKLIB) $(cls)
	$(F77LOADER) $(F77LOADFLAGS) -o $(clsexe) $(cls) $(LIBS)
	$(MAKE) $(TESTINGdir)/LS.dat
$(zlsexe): $(SCALAPACKLIB) $(zls)
	$(F77LOADER) $(F77LOADFLAGS) -o $(zlsexe) $(zls) $(LIBS)
	$(MAKE) $(TESTINGdir)/LS.dat

$(slu): $(FRC)
$(dlu): $(FRC)
$(clu): $(FRC)
$(zlu): $(FRC)

$(sdblu): $(FRC)
$(ddblu): $(FRC)
$(cdblu): $(FRC)
$(zdblu): $(FRC)

$(sdtlu): $(FRC)
$(ddtlu): $(FRC)
$(cdtlu): $(FRC)
$(zdtlu): $(FRC)


$(sllt): $(FRC)
$(dllt): $(FRC)
$(cllt): $(FRC)
$(zllt): $(FRC)

$(spbllt): $(FRC)
$(dpbllt): $(FRC)
$(cpbllt): $(FRC)
$(zpbllt): $(FRC)

$(sptllt): $(FRC)
$(dptllt): $(FRC)
$(cptllt): $(FRC)
$(zptllt): $(FRC)

$(sinv): $(FRC)
$(dinv): $(FRC)
$(cinv): $(FRC)
$(zinv): $(FRC)

$(sqr): $(FRC)
$(dqr): $(FRC)
$(cqr): $(FRC)
$(zqr): $(FRC)

$(sls): $(FRC)
$(dls): $(FRC)
$(cls): $(FRC)
$(zls): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

psludriver.o: psludriver.f
	$(F77) $(DRVOPTS) -c $<
pdludriver.o: pdludriver.f
	$(F77) $(DRVOPTS) -c $<

=== TOOLS/LAPACK/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Tools - LAPACK Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 16, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

ALLAUX = icopy.o 

SCATGEN = slatm1.o slaran.o slarnd.o

SMATGEN = slatms.o slagge.o slagsy.o slarot.o

CMATGEN = clarnv.o clatm1.o clatms.o clagge.o claghe.o clagsy.o clarot.o \
          clarnd.o

DZATGEN = dlatm1.o dlaran.o dlarnd.o

DMATGEN = dlatms.o dlagge.o dlagsy.o dlarot.o

ZMATGEN = zlarnv.o zlatm1.o zlatms.o zlagge.o zlaghe.o zlagsy.o zlarot.o \
          zlarnd.o

all : single complex double complex16

single: $(ALLAUX) $(SMATGEN) $(SCATGEN)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(SLASRC) $(ALLAUX) $(SCLAUX) \
	$(SMATGEN) $(SCATGEN)
	$(RANLIB) $(SCALAPACKLIB)

complex: $(ALLAUX) $(CMATGEN) $(SCATGEN)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(CLASRC) $(ALLAUX) $(SCLAUX) \
	$(CMATGEN) $(SCATGEN)
	$(RANLIB) $(SCALAPACKLIB)

double: $(ALLAUX) $(DMATGEN) $(DZATGEN)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(DLASRC) $(ALLAUX) $(DZLAUX) \
	$(DMATGEN) $(DZATGEN)
	$(RANLIB) $(SCALAPACKLIB)

complex16: $(ALLAUX) $(ZMATGEN) $(DZATGEN)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(ZLASRC) $(ALLAUX) $(DZLAUX) \
	$(ZMATGEN) $(DZATGEN)
	$(RANLIB) $(SCALAPACKLIB)

$(ALLAUX): $(FRC)
$(SCLAUX): $(FRC)
$(DZLAUX): $(FRC)

$(SCATGEN): $(FRC)
$(SMATGEN): $(FRC)
$(CMATGEN): $(FRC)
$(DZATGEN): $(FRC)
$(DMATGEN): $(FRC)
$(ZMATGEN): $(FRC)

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

slamch.o:
	$(F77) -c $(NOOPT) slamch.f

dlamch.o:
	$(F77) -c $(NOOPT) dlamch.f

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

=== PBLAS/SRC/PBBLAS/Makefile ===
############################################################################
#
#  Program:         PBLAS -- (version 2.0 beta)
#
#  Module:          Makefile
#
#  Purpose:         PB-BLAS remaining source Makefile
#
#  Creation date:   August 24, 1997
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../../SLmake.inc

############################################################################
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ../../../SLmake.inc file
#  definitions to match your compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#
#  To remove the object files after the library is created, enter
#       make clean
#  To force the source files to be recompiled, enter, for example,
#       make single FRC=FRC
#
############################################################################

all: single double complex complex16

PBSBLASAUX = pbstran.o pbsmatadd.o pbstrsrt.o pbstrget.o \
             pbstrnv.o pbsvecadd.o pbstrst1.o

PBCBLASAUX = pbctran.o pbcmatadd.o pbctrsrt.o pbctrget.o \
             pbctrnv.o pbcvecadd.o pbctrst1.o

PBDBLASAUX = pbdtran.o pbdmatadd.o pbdtrsrt.o pbdtrget.o \
             pbdtrnv.o pbdvecadd.o pbdtrst1.o

PBZBLASAUX = pbztran.o pbzmatadd.o pbztrsrt.o pbztrget.o \
             pbztrnv.o pbzvecadd.o pbztrst1.o

#---------------------------------------------------------------------------

$(PBSBLASAUX) : $(FRC)
$(PBCBLASAUX) : $(FRC)
$(PBDBLASAUX) : $(FRC)
$(PBZBLASAUX) : $(FRC)

#---------------------------------------------------------------------------

single: $(PBSBLASAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(PBSBLASAUX)
	$(RANLIB) $(SCALAPACKLIB)

double: $(PBDBLASAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(PBDBLASAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex: $(PBCBLASAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(PBCBLASAUX)
	$(RANLIB) $(SCALAPACKLIB)

complex16: $(PBZBLASAUX)
	$(ARCH) $(ARCHFLAGS) $(SCALAPACKLIB) $(PBZBLASAUX)
	$(RANLIB) $(SCALAPACKLIB)

#---------------------------------------------------------------------------

FRC:
	@FRC=$(FRC)

clean :
	rm -f *.o

.f.o : ; $(F77) -c $(F77FLAGS) $*.f

=== debian/changelog ===
scalapack (1.8.0-9build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 16 Dec 2013 17:08:10 -0500

scalapack (1.8.0-9) unstable; urgency=low

  * scalapack failed to build from source with the new mpich2's targets. For
    avoiding this, scalapack has been linked explicitly with -lmpich -lmpl.
    Thanks again to Adam C Powell IV for providing a solution. (Closes: #653610)

 -- Muammar El Khatib <muammar@debian.org>  Thu, 29 Dec 2011 20:24:51 +0100

scalapack (1.8.0-8) unstable; urgency=low

  * Added mpich2 targets in debian/rules. Thanks to Adam C Powell IV for
    providing a patch. (Closes: 652313)

 -- Muammar El Khatib <muammar@debian.org>  Thu, 22 Dec 2011 16:58:01 -0500

scalapack (1.8.0-7) unstable; urgency=low

  * Test command execution failure caused due to incompatible file location in
    package scalapack-test-common has been fixed adding symbolic links pointing
    files to the correct location. (Closes: #588404) Files cannot be moved
    directly to /usr/lib/scalapack becasuse they are .dat files. Refer to
    Filesystem Hierarchy Standard | /usr/share : Architecture-independent data
    for more information.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Maintainer's mail has been changed.
  * Patched Mptr offset calculation to enable arrays with more than
    2^31 bytes. Thanks to David Gleich.

 -- Muammar El Khatib <muammar@debian.org>  Tue, 18 Sep 2011 08:26:29 +0200

scalapack (1.8.0-6) unstable; urgency=low

  * debian/rules file has been updated for linking against blas and lapack
    instead of blas-3gf and lapack-3. With this change, scalapack does not fail
    to build from source. (Closes: #577895)
  * debian/source directory has been created for specifying 1.0 version in the
    file debian/source/format.

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Mon, 19 Apr 2010 15:07:49 -0430

scalapack (1.8.0-5) unstable; urgency=low

  * Bumped standards version to 3.8.4.
  * diff.gz file has been cleaned in this revision.
  * debian/control: ${misc:Depends} has been added to Depends control field.

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Mon, 01 Feb 2010 12:25:42 -0430

scalapack (1.8.0-4) unstable; urgency=low

  * Bumped standards version to 3.8.3.
  * scalapack-pvm-test does not depend on scalapack1-pvm anymore. To accomplish
    this, the debian/shlibs.local file has been updated  (Closes: #549707)
  * Typo in scalapack-test-common's description has been fixed.
    (Closes: #557848)

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Fri, 18 Dec 2009 18:17:45 -0430

scalapack (1.8.0-3.1) unstable; urgency=low

  * NMU as authorized by maintainer.
  * Changed to build against mpi-default-dev. (Closes: #491028)
  * Replaced two sets of shlib, -dev and -test packages with just one.
  * Changed binary package names to generic mpi and to comply with policy
    i.e. libscalapack-mpi1 and libblacs-mpi-dev.
  * Added sections to all packages.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 04 May 2009 21:59:43 -0400

scalapack (1.8.0-3) unstable; urgency=low

  * Bumped standards version to 3.8.0.
  * Updated build dependency to debhelper >=6
  * Bug: 'FTBFS: symbols not found' has been fixed in this revision.
   (Closes: #483323)

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Fri, 06 Jun 2008 13:22:03 -0430

scalapack (1.8.0-2) unstable; urgency=low

  * Bumped standards version to 3.7.3.
  * Scalpack is now building with Gfortran instead of G77. Thanks to Kumar
    Appaiah for providing a patch. (Closes: #465392)
  * Bug:' FTBFS: psblas1tst.f:(.text+0x156): undefined reference to
    `blacs_pinfo__'' has been fixed in this revision. (Closes: #462510)

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Sun, 09 Mar 2008 12:33:24 -0430

scalapack (1.8.0-1) unstable; urgency=low

  * New upstream release.
  * Updated build dependency to debhelper >= 5
  * Line in debian/rules that seted DH_COMPAT globally was deleted and a
    separated debian/compat file created.

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Sat, 07 Apr 2007 00:00:13 -0400

scalapack (1.7.4-2) unstable; urgency=low

  * Problems with symbolic link references the wrong file
    have been fixed. Closes: #380140
  * Updated build dependency to debhelper >= 4.
  * Moved architecture independent test input data to /usr/share/scalapack.
  * Thanks to Philipp Frauenfelder.
  * New maintainer. Closes: #335006

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Sun, 17 Sep 2006 13:51:20 -0400

scalapack (1.7.4-1) unstable; urgency=low

  * New upstream release
  * Bumped standards version to 3.7.2 - no changes

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed, 12 Jul 2006 22:49:44 +0200

scalapack (1.7-11) unstable; urgency=low

  * Also allow building against atlas3-*-dev. Closes: #334002

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed, 26 Oct 2005 21:38:45 +0200

scalapack (1.7-10) unstable; urgency=low

  * Remove f2c from build depends and from SLmake.inc. Closes: #332955

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Thu, 13 Oct 2005 21:36:17 +0200

scalapack (1.7-9) unstable; urgency=low

  * Recompile against C++ ABI changed mpich (and change build depends).
    Closes: #325810

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed, 31 Aug 2005 23:05:18 +0200

scalapack (1.7-8) unstable; urgency=low

  * Adjust build deps for LAPACK and BLAS and also change the linking
    wrt. these libraries. Closes: #302425. Thanks to Camm Maguire

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Thu, 28 Apr 2005 13:55:52 +0200

scalapack (1.7-7) unstable; urgency=low

  * Adjust manual dependencies. Closes: #229831

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sat, 21 Feb 2004 09:09:13 +0100

scalapack (1.7-6) unstable; urgency=low

  * Rebuild against lam4. Closes: #229831
  * Better package descriptions.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sun, 15 Feb 2004 14:56:26 +0100


=== debian/control ===
Source: scalapack
Section: devel
Priority: extra
Maintainer: Muammar El Khatib <muammar@debian.org>
Standards-Version: 3.8.4
Build-Depends: mpi-default-dev, pvm-dev, blacs-pvm-dev, gfortran, liblapack-dev, libblas-dev, debhelper (>= 6), libblacs-mpi-dev
Homepage: http://www.netlib.org/scalapack/

Package: libscalapack-mpi1
Section: libs
Architecture: any
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack1-mpich, scalapack1-lam
Replaces: scalapack1-mpich, scalapack1-lam
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs. for MPI
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses MPI. There are packages for the shared libraries (this one), for
 the static libraries and the development files and for test programs.
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: libscalapack-mpi-dev
Section: libdevel
Architecture: any
Depends: libscalapack-mpi1 (= ${binary:Version}), libblacs-mpi-dev, ${misc:Depends}
Conflicts: scalapack-mpich-dev, scalapack-lam-dev
Replaces: scalapack-mpich-dev, scalapack-lam-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev. files for MPICH
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses MPI.
 .
 The package is available for LAM and MPICH. This package uses MPICH. There
 are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: scalapack-mpi-test
Section: math
Architecture: any
Depends: scalapack-test-common, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack-mpich-test, scalapack-lam-test
Replaces: scalapack-mpich-test, scalapack-lam-test
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Test files for MPICH
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses MPI.
 .
 The package is available for LAM and MPICH. This package uses MPICH. There
 are packages for the shared libraries, for the static libraries and
 the development files and for test programs (this one).
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: libscalapack-pvm1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Conflicts: scalapack1-pvm
Replaces: scalapack1-pvm
Description: Scalable Linear Algebra Package - Shared libs. for PVM
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries (this one), for the static
 libraries and the development files and for test programs.
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: libscalapack-pvm-dev
Section: libdevel
Architecture: any
Depends: libscalapack-pvm1 (= ${binary:Version}), blacs-pvm-dev, pvm-dev, ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev. files for PVM
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: scalapack-pvm-test
Section: math
Architecture: any
Depends: scalapack-test-common, ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Test files for PVM
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files and for test programs (this one).
 .
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.

Package: scalapack-test-common
Architecture: all
Depends: ${misc:Depends}
Suggests: scalapack-lam-test | scalapack-mpich-test | scalapack-pvm-test
Description: Test data for ScaLAPACK testers
 ScaLAPACK is the parallel version of LAPACK and is used on Beowulf type
 clusters.
 .
 You can choose between an implementation based on MPI or PVM. This package
 provides test data for all ScaLAPACK packages (MPICH, LAM and PVM versions).

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.
# Handmodified by P. Frauenfelder for debhelper support, 5 Sept 1998


package=scalapack

version:=$(shell dpkg-parsechangelog | grep Version: | cut -d ' ' -f 2 | cut -d '-' -f 1)
version_major:=$(shell echo $(version) | cut -d '.' -f 1)

topdir=$(shell pwd)

include /usr/share/mpi-default-dev/debian_defaults
SCALAPACK_MPI=$(ARCH_DEFAULT_MPI_IMPL)

build: build-$(SCALAPACK_MPI) build-pvm

build-openmpi: build-stamp-openmpi

build-lam: build-stamp-lam

build-mpich: build-stamp-mpich

build-mpich2: build-stamp-mpich2

build-pvm: build-stamp-pvm

build-stamp-openmpi:
	dh_testdir

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the shared libraries
	echo *** building shared libraries for openmpi ***
	BASEDIR=$(topdir) MPI=openmpi FPIC=-fPIC make lib
	mkdir -p tmp
	set -e ;\
	for i in scalapack ; do \
	  cd tmp ;\
	  ar x ../$${i}_openmpi.a ;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-openmpi.so.$(version_major) -o \
	    lib$$i-openmpi.so.$(version) tmp/*.o -lblas -llapack -lblacsCinit-openmpi -lblacs-openmpi -L/usr/lib/openmpi/lib -lmpi -lmpi_f77 -lgfortran;\
	  ln -snf lib$$i-openmpi.so.$(version) lib$$i-openmpi.so.$(version_major) ;\
	  ln -snf lib$$i-openmpi.so.$(version_major) lib$$i-openmpi.so ;\
	  rm tmp/* ;\
	done
	rmdir tmp
#	for i in $$(find -name "*.f"); do \
#		if grep '^[^\*].*TOTMEM *= *' $$i | grep -v 64000000 >/dev/null ; then \
#		cat $$i | sed 's,\(^[^\*].*TOTMEM *= *\)[0-9]*,\164000000,g' >tmp ;\
#		mv tmp $$i;\
#		fi;\
#	done

# the testing binaries
	echo *** building static testing binaries for openmpi ***
	BASEDIR=$(topdir) MPI=openmpi BUILD=shared make exe
	set -e ;\
	cd TESTING ;\
	for i in $$(find -name 'x*' -maxdepth 1 ! -name 'x*-lam' ! -name 'x*-mpich' ! -name 'x*-pvm'); do \
	  mv $$i $$i-openmpi ;\
	done

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the static libraries
	echo *** building static libraries for openmpi ***
	BASEDIR=$(topdir) MPI=openmpi make lib

	touch build-stamp-openmpi

build-stamp-lam:
	dh_testdir

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the shared libraries
	echo *** building shared libraries for lam ***
	BASEDIR=$(topdir) MPI=lam FPIC=-fPIC make lib
	mkdir -p tmp
	set -e ;\
	for i in scalapack ; do \
	  cd tmp ;\
	  ar x ../$${i}_lam.a ;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-lam.so.$(version_major) -o \
	    lib$$i-lam.so.$(version) tmp/*.o -lblas -llapack -lblacsCinit-lam -lblacs-lam -llam -lgfortran;\
	  ln -snf lib$$i-lam.so.$(version) lib$$i-lam.so.$(version_major) ;\
	  ln -snf lib$$i-lam.so.$(version_major) lib$$i-lam.so ;\
	  rm tmp/* ;\
	done
	rmdir tmp
#	for i in $$(find -name "*.f"); do \
#		if grep '^[^\*].*TOTMEM *= *' $$i | grep -v 64000000 >/dev/null ; then \
#		cat $$i | sed 's,\(^[^\*].*TOTMEM *= *\)[0-9]*,\164000000,g' >tmp ;\
#		mv tmp $$i;\
#		fi;\
#	done

# the testing binaries
	echo *** building static testing binaries for lam ***
	BASEDIR=$(topdir) MPI=lam BUILD=shared make exe
	set -e ;\
	cd TESTING ;\
	for i in $$(find -name 'x*' -maxdepth 1 ! -name 'x*-openmpi' ! -name 'x*-mpich' ! -name 'x*-pvm'); do \
	  mv $$i $$i-lam ;\
	done

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the static libraries
	echo *** building static libraries for lam ***
	BASEDIR=$(topdir) MPI=lam make lib

	touch build-stamp-lam

build-stamp-mpich:
	dh_testdir

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the shared libraries
	echo *** building shared libraries for mpich ***
	BASEDIR=$(topdir) MPI=mpich FPIC=-fPIC make lib
	mkdir -p tmp
	set -e ;\
	for i in scalapack ; do \
	  cd tmp ;\
	  ar x ../$${i}_mpich.a ;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-mpich.so.$(version_major) -o \
	    lib$$i-mpich.so.$(version) tmp/*.o -lblas -llapack -lblacsCinit-mpich -lblacs-mpich -L /usr/lib/mpich/lib/shared -lmpich -lgfortran;\
	  ln -snf lib$$i-mpich.so.$(version) lib$$i-mpich.so.$(version_major) ;\
	  ln -snf lib$$i-mpich.so.$(version_major) lib$$i-mpich.so ;\
	  rm tmp/* ;\
	done
	rmdir tmp

# the testing binaries
	echo *** building static testing binaries for mpich ***
	BASEDIR=$(topdir) MPI=mpich BUILD=shared make exe
	set -e ;\
	cd TESTING ;\
	for i in $$(find -name 'x*'  -maxdepth 1 ! -name 'x*-openmpi' ! -name 'x*-lam' ! -name 'x*-pvm'); do \
	  mv $$i $$i-mpich ;\
	done

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the static libraries
	echo *** building static libraries for mpich ***
	BASEDIR=$(topdir) MPI=mpich make lib

	touch build-stamp-mpich

build-stamp-mpich2:
	dh_testdir

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the shared libraries
	echo *** building shared libraries for mpich2 ***
	BASEDIR=$(topdir) MPI=mpich2 FPIC=-fPIC make lib
	mkdir -p tmp
	set -e ;\
	for i in scalapack ; do \
	  cd tmp ;\
	  ar x ../$${i}_mpich2.a ;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-mpich2.so.$(version_major) -o \
	    lib$$i-mpich2.so.$(version) tmp/*.o -lblas -llapack -lblacsCinit-mpich2 -lblacs-mpich2 -lmpich -lmpl -lgfortran;\
	  ln -snf lib$$i-mpich2.so.$(version) lib$$i-mpich2.so.$(version_major) ;\
	  ln -snf lib$$i-mpich2.so.$(version_major) lib$$i-mpich2.so ;\
	  rm tmp/* ;\
	done
	rmdir tmp
#	for i in $$(find -name "*.f"); do \
#		if grep '^[^\*].*TOTMEM *= *' $$i | grep -v 64000000 >/dev/null ; then \
#		cat $$i | sed 's,\(^[^\*].*TOTMEM *= *\)[0-9]*,\164000000,g' >tmp ;\
#		mv tmp $$i;\
#		fi;\
#	done

# the testing binaries
	echo *** building static testing binaries for mpich2 ***
	BASEDIR=$(topdir) MPI=mpich2 BUILD=shared make exe
	set -e ;\
	cd TESTING ;\
	for i in $$(find -name 'x*' -maxdepth 1 ! -name 'x*-openmpi' ! -name 'x*-mpich*' ! -name 'x*-pvm'); do \
	  mv $$i $$i-mpich2 ;\
	done

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the static libraries
	echo *** building static libraries for mpich2 ***
	BASEDIR=$(topdir) MPI=mpich2 make lib

	touch build-stamp-mpich2

build-stamp-pvm:
	dh_testdir

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the shared libraries
	echo *** building shared libraries for pvm ***
	BASEDIR=$(topdir) MPI=pvm FPIC=-fPIC make lib
	mkdir -p tmp
	set -e ;\
	for i in scalapack ; do \
	  cd tmp ;\
	  ar x ../$${i}_pvm.a ;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-pvm.so.$(version_major) -o \
	    lib$$i-pvm.so.$(version) tmp/*.o -lblas -llapack -lblacs-pvm -lpvm3 -lgfortran;\
	  ln -snf lib$$i-pvm.so.$(version) lib$$i-pvm.so.$(version_major) ;\
	  ln -snf lib$$i-pvm.so.$(version_major) lib$$i-pvm.so ;\
	  rm tmp/* ;\
	done
	rmdir tmp

# the testing binaries
	echo *** building static testing binaries for pvm ***
	BASEDIR=$(topdir) MPI=pvm BUILD=shared make exe
	set -e ;\
	cd TESTING ;\
	for i in $$(find -name 'x*'  -maxdepth 1 ! -name 'x*-openmpi' ! -name 'x*-lam' ! -name 'x*-mpich*'); do \
	  mv $$i $$i-pvm ;\
	done

# next is a clean
	echo *** cleaning object files ***
	BASEDIR=$(topdir) make clean

# build the static libraries
	echo *** building static libraries for pvm ***
	BASEDIR=$(topdir) MPI=pvm make lib

	touch build-stamp-pvm

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp-* install-stamp-* install-dirs-stamp
	BASEDIR=$(topdir) make clean
	rm -f *.a
	rm -f *so*
	rm -f TESTING/x*
	rm -fr tmp
	rm -f PBLAS/TIMING/PB_Cabort.c PBLAS/TIMING/PB_Cwarn.c PBLAS/TESTING/PB_Cabort.c PBLAS/TESTING/PB_Cwarn.c
#	for i in $$(find -name "*.f"); do \
#		if grep '^[^\*].*TOTMEM *= *' $$i | grep 64000000 >/dev/null ; then\
#		cat $$i | sed -e 's/\(^[^\*].*TOTMEM *= *\)[0-9]*,/\12000000,/g' -e 's/\(^[^\*].*TOTMEM *= *\)[0-9]*\( *)\)/\13000000\2/g'>tmp ;\
#		mv tmp $$i;\
#		fi;\
